Index: /trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/HeuristicLab.GP.StructureIdentification.Classification-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/HeuristicLab.GP.StructureIdentification.Classification-3.3.csproj	(revision 2340)
+++ /trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/HeuristicLab.GP.StructureIdentification.Classification-3.3.csproj	(revision 2341)
@@ -83,4 +83,6 @@
     <Compile Include="ClassificationMeanSquaredErrorEvaluator.cs" />
     <Compile Include="ConfusionMatrixEvaluator.cs" />
+    <Compile Include="TargetClassesCalculator.cs" />
+    <Compile Include="DefaultClassificationAlgorithmOperators.cs" />
     <Compile Include="GPClassificationEvaluatorBase.cs" />
     <Compile Include="CrossValidation.cs" />
@@ -109,4 +111,8 @@
       <Project>{F473D9AF-3F09-4296-9F28-3C65118DAFFA}</Project>
       <Name>HeuristicLab.Data-3.2</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.GP.Algorithms\3.2\HeuristicLab.GP.Algorithms-3.2.csproj">
+      <Project>{3127719F-110E-4558-8845-98559DBB422D}</Project>
+      <Name>HeuristicLab.GP.Algorithms-3.2</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.GP.Interfaces\3.3\HeuristicLab.GP.Interfaces-3.3.csproj">
Index: /trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/OffspringSelectionGP.cs
===================================================================
--- /trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/OffspringSelectionGP.cs	(revision 2340)
+++ /trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/OffspringSelectionGP.cs	(revision 2341)
@@ -27,9 +27,10 @@
   public class OffspringSelectionGP : HeuristicLab.GP.StructureIdentification.OffspringSelectionGP, IClassificationAlgorithm {
 
-    protected override IOperator CreateBestSolutionProcessor() {
-      IOperator seq = new SequentialProcessor();
-      seq.AddSubOperator(base.CreateBestSolutionProcessor());
-      seq.AddSubOperator(StandardGP.BestSolutionProcessor);
-      return seq;
+    protected override IOperator CreateProblemInjector() {
+      return DefaultClassificationAlgorithmOperators.CreateProblemInjector();
+    }
+
+    protected override IOperator CreatePostProcessingOperator() {
+      return DefaultClassificationAlgorithmOperators.CreatePostProcessingOperator();
     }
   }
Index: /trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/StandardGP.cs
===================================================================
--- /trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/StandardGP.cs	(revision 2340)
+++ /trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/StandardGP.cs	(revision 2341)
@@ -23,54 +23,10 @@
 using HeuristicLab.Modeling;
 using HeuristicLab.Operators;
+using System;
 
 namespace HeuristicLab.GP.StructureIdentification.Classification {
   public class StandardGP : HeuristicLab.GP.StructureIdentification.StandardGP, IClassificationAlgorithm {
-    protected override IOperator CreateBestSolutionProcessor() {
-      IOperator bestSolutionProcessor = BestSolutionProcessor;
-      bestSolutionProcessor.AddSubOperator(base.CreateBestSolutionProcessor());
-      return bestSolutionProcessor;
-    }
-
-    internal static IOperator BestSolutionProcessor {
-      get {
-        SequentialProcessor seq = new SequentialProcessor();
-        AccuracyEvaluator trainingAccuracy = new AccuracyEvaluator();
-        trainingAccuracy.GetVariableInfo("Accuracy").ActualName = "TrainingAccuracy";
-        trainingAccuracy.GetVariableInfo("SamplesStart").ActualName = "ActualTrainingSamplesStart";
-        trainingAccuracy.GetVariableInfo("SamplesEnd").ActualName = "ActualTrainingSamplesEnd";
-
-        AccuracyEvaluator validationAccuracy = new AccuracyEvaluator();
-        validationAccuracy.GetVariableInfo("Accuracy").ActualName = "ValidationAccuracy";
-        validationAccuracy.GetVariableInfo("SamplesStart").ActualName = "ValidationSamplesStart";
-        validationAccuracy.GetVariableInfo("SamplesEnd").ActualName = "ValidationSamplesEnd";
-
-        AccuracyEvaluator testAccuracy = new AccuracyEvaluator();
-        testAccuracy.GetVariableInfo("Accuracy").ActualName = "TestAccuracy";
-        testAccuracy.GetVariableInfo("SamplesStart").ActualName = "TestSamplesStart";
-        testAccuracy.GetVariableInfo("SamplesEnd").ActualName = "TestSamplesEnd";
-
-        ConfusionMatrixEvaluator trainingConfusionMatrix = new ConfusionMatrixEvaluator();
-        trainingConfusionMatrix.GetVariableInfo("ConfusionMatrix").ActualName = "TrainingConfusionMatrix";
-        trainingConfusionMatrix.GetVariableInfo("SamplesStart").ActualName = "ActualTrainingSamplesStart";
-        trainingConfusionMatrix.GetVariableInfo("SamplesEnd").ActualName = "ActualTrainingSamplesEnd";
-
-        ConfusionMatrixEvaluator validationConfusionMatrix = new ConfusionMatrixEvaluator();
-        validationConfusionMatrix.GetVariableInfo("ConfusionMatrix").ActualName = "ValidationConfusionMatrix";
-        validationConfusionMatrix.GetVariableInfo("SamplesStart").ActualName = "ValidationSamplesStart";
-        validationConfusionMatrix.GetVariableInfo("SamplesEnd").ActualName = "ValidationSamplesEnd";
-
-        ConfusionMatrixEvaluator testConfusionMatrix = new ConfusionMatrixEvaluator();
-        testConfusionMatrix.GetVariableInfo("ConfusionMatrix").ActualName = "TestConfusionMatrix";
-        testConfusionMatrix.GetVariableInfo("SamplesStart").ActualName = "TestSamplesStart";
-        testConfusionMatrix.GetVariableInfo("SamplesEnd").ActualName = "TestSamplesEnd";
-
-        seq.AddSubOperator(trainingAccuracy);
-        seq.AddSubOperator(validationAccuracy);
-        seq.AddSubOperator(testAccuracy);
-        seq.AddSubOperator(trainingConfusionMatrix);
-        seq.AddSubOperator(validationConfusionMatrix);
-        seq.AddSubOperator(testConfusionMatrix);
-        return seq;
-      }
+    protected override IOperator CreatePostProcessingOperator() {
+      return DefaultClassificationAlgorithmOperators.CreatePostProcessingOperator();
     }
   }
Index: /trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/TargetClassesCalculator.cs
===================================================================
--- /trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/TargetClassesCalculator.cs	(revision 2341)
+++ /trunk/sources/HeuristicLab.GP.StructureIdentification.Classification/3.3/TargetClassesCalculator.cs	(revision 2341)
@@ -0,0 +1,51 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.DataAnalysis;
+using System.Linq;
+
+namespace HeuristicLab.GP.StructureIdentification.Classification {
+  public class TargetClassesCalculator : OperatorBase {
+
+    public TargetClassesCalculator()
+      : base() {
+      AddVariableInfo(new VariableInfo("Dataset", "The dataset", typeof(Dataset), VariableKind.In));
+      AddVariableInfo(new VariableInfo("TargetVariable", "Index of the target variable", typeof(IntData), VariableKind.In));
+      AddVariableInfo(new VariableInfo("TargetClassValues", "The original class values of target variable (for instance negative=0 and positive=1).", typeof(ItemList<DoubleData>), VariableKind.New));
+    }
+
+    public override IOperation Apply(IScope scope) {
+      Dataset dataset = GetVariableValue<Dataset>("Dataset", scope, true);
+      int targetVariable = GetVariableValue<IntData>("TargetVariable", scope, true).Data;
+
+      ItemList<DoubleData> classes = new ItemList<DoubleData>();
+      foreach(double x in dataset.GetVariableValues(targetVariable).Distinct().OrderBy(v=>v)) {
+        classes.Add(new DoubleData(x));
+      }
+
+      scope.AddVariable(new HeuristicLab.Core.Variable(scope.TranslateName("TargetClassValues"), classes));
+      return null;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.GP.StructureIdentification.TimeSeries/3.3/DefaultTimeSeriesOperators.cs
===================================================================
--- /trunk/sources/HeuristicLab.GP.StructureIdentification.TimeSeries/3.3/DefaultTimeSeriesOperators.cs	(revision 2341)
+++ /trunk/sources/HeuristicLab.GP.StructureIdentification.TimeSeries/3.3/DefaultTimeSeriesOperators.cs	(revision 2341)
@@ -0,0 +1,97 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.DataAnalysis;
+using HeuristicLab.GP.Interfaces;
+using HeuristicLab.Operators;
+using HeuristicLab.Modeling;
+using HeuristicLab.Logging;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.GP.StructureIdentification.TimeSeries {
+  internal static class DefaultTimeSeriesOperators {
+    internal static IOperator CreateFunctionLibraryInjector() {
+      CombinedOperator op = new CombinedOperator();
+      op.Name = "FunctionLibraryInjector";
+      SequentialProcessor seq = new SequentialProcessor();
+      FunctionLibraryInjector funLibInjector = new FunctionLibraryInjector();
+      funLibInjector.GetVariable("Differentials").Value = new BoolData(true);
+      seq.AddSubOperator(funLibInjector);
+      seq.AddSubOperator(new HL3TreeEvaluatorInjector());
+      op.OperatorGraph.AddOperator(seq);
+      op.OperatorGraph.InitialOperator = seq;
+      return op;
+    }
+
+    internal static IOperator CreateProblemInjector() {
+      CombinedOperator op = new CombinedOperator();
+      op.Name = "ProblemInjector";
+      SequentialProcessor seq = new SequentialProcessor();
+      seq.AddSubOperator(new ProblemInjector());
+      op.OperatorGraph.AddOperator(seq);
+      op.OperatorGraph.InitialOperator = seq;
+      return op;
+    }
+
+    internal static IOperator CreatePostProcessingOperator() {
+      SequentialProcessor seq = new SequentialProcessor();
+      seq.AddSubOperator(DefaultStructureIdentificationAlgorithmOperators.CreatePostProcessingOperator());
+
+      UniformSequentialSubScopesProcessor subScopesProc = new UniformSequentialSubScopesProcessor();
+      SequentialProcessor individualProc = new SequentialProcessor();
+      subScopesProc.AddSubOperator(individualProc);
+      seq.AddSubOperator(subScopesProc);
+
+      TheilInequalityCoefficientEvaluator trainingTheil = new TheilInequalityCoefficientEvaluator();
+      trainingTheil.Name = "TrainingTheilInequalityEvaluator";
+      trainingTheil.GetVariableInfo("SamplesStart").ActualName = "TrainingSamplesStart";
+      trainingTheil.GetVariableInfo("SamplesEnd").ActualName = "TrainingSamplesEnd";
+      trainingTheil.GetVariableInfo("TheilInequalityCoefficient").ActualName = "TrainingTheilInequalityCoefficient";
+      trainingTheil.GetVariableInfo("TheilInequalityCoefficientBias").ActualName = "TrainingTheilInequalityCoefficientBias";
+      trainingTheil.GetVariableInfo("TheilInequalityCoefficientVariance").ActualName = "TrainingTheilInequalityCoefficientVariance";
+      trainingTheil.GetVariableInfo("TheilInequalityCoefficientCovariance").ActualName = "TrainingTheilInequalityCoefficientCovariance";
+
+      TheilInequalityCoefficientEvaluator validationTheil = new TheilInequalityCoefficientEvaluator();
+      validationTheil.Name = "ValidationTheilInequalityEvaluator";
+      validationTheil.GetVariableInfo("SamplesStart").ActualName = "ValidationSamplesStart";
+      validationTheil.GetVariableInfo("SamplesEnd").ActualName = "ValidationSamplesEnd";
+      validationTheil.GetVariableInfo("TheilInequalityCoefficient").ActualName = "ValidationTheilInequalityCoefficient";
+      validationTheil.GetVariableInfo("TheilInequalityCoefficientBias").ActualName = "ValidationTheilInequalityCoefficientBias";
+      validationTheil.GetVariableInfo("TheilInequalityCoefficientVariance").ActualName = "ValidationTheilInequalityCoefficientVariance";
+      validationTheil.GetVariableInfo("TheilInequalityCoefficientCovariance").ActualName = "ValidationTheilInequalityCoefficientCovariance";
+
+      TheilInequalityCoefficientEvaluator testTheil = new TheilInequalityCoefficientEvaluator();
+      testTheil.Name = "TestTheilInequalityEvaluator";
+      testTheil.GetVariableInfo("SamplesStart").ActualName = "TestSamplesStart";
+      testTheil.GetVariableInfo("SamplesEnd").ActualName = "TestSamplesEnd";
+      testTheil.GetVariableInfo("TheilInequalityCoefficient").ActualName = "TestTheilInequalityCoefficient";
+      testTheil.GetVariableInfo("TheilInequalityCoefficientBias").ActualName = "TestTheilInequalityCoefficientBias";
+      testTheil.GetVariableInfo("TheilInequalityCoefficientVariance").ActualName = "TestTheilInequalityCoefficientVariance";
+      testTheil.GetVariableInfo("TheilInequalityCoefficientCovariance").ActualName = "TestTheilInequalityCoefficientCovariance";
+
+      individualProc.AddSubOperator(trainingTheil);
+      individualProc.AddSubOperator(validationTheil);
+      individualProc.AddSubOperator(testTheil);
+      return seq;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.GP.StructureIdentification.TimeSeries/3.3/HeuristicLab.GP.StructureIdentification.TimeSeries-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.GP.StructureIdentification.TimeSeries/3.3/HeuristicLab.GP.StructureIdentification.TimeSeries-3.3.csproj	(revision 2340)
+++ /trunk/sources/HeuristicLab.GP.StructureIdentification.TimeSeries/3.3/HeuristicLab.GP.StructureIdentification.TimeSeries-3.3.csproj	(revision 2341)
@@ -83,4 +83,5 @@
   <ItemGroup>
     <Compile Include="AveragePercentageChangeEvaluator.cs" />
+    <Compile Include="DefaultTimeSeriesOperators.cs" />
     <Compile Include="HeuristicLabGPTimeSeriesPlugin.cs" />
     <Compile Include="OffspringSelectionGP.cs" />
@@ -102,4 +103,8 @@
       <Project>{F473D9AF-3F09-4296-9F28-3C65118DAFFA}</Project>
       <Name>HeuristicLab.Data-3.2</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.GP.Algorithms\3.2\HeuristicLab.GP.Algorithms-3.2.csproj">
+      <Project>{3127719F-110E-4558-8845-98559DBB422D}</Project>
+      <Name>HeuristicLab.GP.Algorithms-3.2</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.GP.Interfaces\3.3\HeuristicLab.GP.Interfaces-3.3.csproj">
Index: /trunk/sources/HeuristicLab.GP.StructureIdentification.TimeSeries/3.3/OffspringSelectionGP.cs
===================================================================
--- /trunk/sources/HeuristicLab.GP.StructureIdentification.TimeSeries/3.3/OffspringSelectionGP.cs	(revision 2340)
+++ /trunk/sources/HeuristicLab.GP.StructureIdentification.TimeSeries/3.3/OffspringSelectionGP.cs	(revision 2341)
@@ -23,42 +23,46 @@
 using HeuristicLab.Modeling;
 using HeuristicLab.Operators;
+using System;
+using HeuristicLab.Data;
+using HeuristicLab.GP.Algorithms;
 
 namespace HeuristicLab.GP.StructureIdentification.TimeSeries {
   public class OffspringSelectionGP : HeuristicLab.GP.StructureIdentification.OffspringSelectionGP, ITimeSeriesAlgorithm {
-    public override IOperator ProblemInjector {
-      get {
-        CombinedOperator algo = (CombinedOperator)Engine.OperatorGraph.InitialOperator;
-        return algo.OperatorGraph.InitialOperator.SubOperators[1];
-      }
-      set {
-        CombinedOperator algo = (CombinedOperator)Engine.OperatorGraph.InitialOperator;
-        algo.OperatorGraph.InitialOperator.RemoveSubOperator(1);
-        value.Name = "ProblemInjector";
-        algo.OperatorGraph.InitialOperator.AddSubOperator(value, 1);
-      }
+
+    public int MinTimeOffset {
+      get { return GetVariableInjector().GetVariable("MinTimeOffset").GetValue<IntData>().Data; }
+      set { GetVariableInjector().GetVariable("MinTimeOffset").GetValue<IntData>().Data = value; }
+    }
+
+    public int MaxTimeOffset {
+      get { return GetVariableInjector().GetVariable("MaxTimeOffset").GetValue<IntData>().Data; }
+      set { GetVariableInjector().GetVariable("MaxTimeOffset").GetValue<IntData>().Data = value; }
+    }
+
+    public bool UseEstimatedTargetValue {
+      get { return GetVariableInjector().GetVariable("UseEstimatedTargetValue").GetValue<BoolData>().Data; }
+      set { GetVariableInjector().GetVariable("UseEstimatedTargetValue").GetValue<BoolData>().Data = value; }
+    }
+
+    protected override IOperator CreateProblemInjector() {
+      return DefaultTimeSeriesOperators.CreateProblemInjector();
     }
 
     protected override IOperator CreateFunctionLibraryInjector() {
-      return new FunctionLibraryInjector();
+      return DefaultTimeSeriesOperators.CreateFunctionLibraryInjector();
     }
 
-    protected override IOperator CreateProblemInjector() {
-      return new ProblemInjector();
+    protected override IOperator CreatePostProcessingOperator() {
+      return DefaultTimeSeriesOperators.CreatePostProcessingOperator();
     }
 
-    protected override IOperator CreateBestSolutionProcessor() {
-      SequentialProcessor seq = new SequentialProcessor();
-      seq.AddSubOperator(base.CreateBestSolutionProcessor());
-      seq.AddSubOperator(StandardGP.BestSolutionProcessor);
-      return seq;
+    protected override VariableInjector CreateGlobalInjector() {
+      VariableInjector injector = base.CreateGlobalInjector();
+      injector.AddVariable(new HeuristicLab.Core.Variable("MinTimeOffset", new IntData()));
+      injector.AddVariable(new HeuristicLab.Core.Variable("MaxTimeOffset", new IntData()));
+      injector.AddVariable(new HeuristicLab.Core.Variable("UseEstimatedTargetValue", new BoolData()));
+      return injector;
     }
 
-    public override IEditor CreateEditor() {
-      return new OffspringSelectionGpEditor(this);
-    }
-
-    public override IView CreateView() {
-      return new OffspringSelectionGpEditor(this);
-    }
   }
 }
Index: /trunk/sources/HeuristicLab.GP.StructureIdentification.TimeSeries/3.3/StandardGP.cs
===================================================================
--- /trunk/sources/HeuristicLab.GP.StructureIdentification.TimeSeries/3.3/StandardGP.cs	(revision 2340)
+++ /trunk/sources/HeuristicLab.GP.StructureIdentification.TimeSeries/3.3/StandardGP.cs	(revision 2341)
@@ -25,112 +25,41 @@
 using HeuristicLab.Modeling;
 using HeuristicLab.Operators;
+using System;
 
 namespace HeuristicLab.GP.StructureIdentification.TimeSeries {
   public class StandardGP : HeuristicLab.GP.StructureIdentification.StandardGP, ITimeSeriesAlgorithm {
-    public override IOperator ProblemInjector {
-      get {
-        CombinedOperator algo = (CombinedOperator)Engine.OperatorGraph.InitialOperator;
-        return algo.OperatorGraph.InitialOperator.SubOperators[1];
-      }
-      set {
-        CombinedOperator algo = (CombinedOperator)Engine.OperatorGraph.InitialOperator;
-        algo.OperatorGraph.InitialOperator.RemoveSubOperator(1);
-        value.Name = "ProblemInjector";
-        algo.OperatorGraph.InitialOperator.AddSubOperator(value, 1);
-      }
+    public int MinTimeOffset {
+      get { return GetVariableInjector().GetVariable("MinTimeOffset").GetValue<IntData>().Data; }
+      set { GetVariableInjector().GetVariable("MinTimeOffset").GetValue<IntData>().Data = value; }
     }
-    
-    protected override IOperator CreateFunctionLibraryInjector() {
-      return new FunctionLibraryInjector();
+
+    public int MaxTimeOffset {
+      get { return GetVariableInjector().GetVariable("MaxTimeOffset").GetValue<IntData>().Data; }
+      set { GetVariableInjector().GetVariable("MaxTimeOffset").GetValue<IntData>().Data = value; }
+    }
+
+    public bool UseEstimatedTargetValue {
+      get { return GetVariableInjector().GetVariable("UseEstimatedTargetValue").GetValue<BoolData>().Data; }
+      set { GetVariableInjector().GetVariable("UseEstimatedTargetValue").GetValue<BoolData>().Data = value; }
     }
 
     protected override IOperator CreateProblemInjector() {
-      return new ProblemInjector();
+      return DefaultTimeSeriesOperators.CreateProblemInjector();
     }
 
-    protected override IOperator CreateBestSolutionProcessor() {
-      SequentialProcessor seq = new SequentialProcessor();
-      seq.AddSubOperator(base.CreateBestSolutionProcessor());
-      seq.AddSubOperator(BestSolutionProcessor);
-      return seq;
+    protected override IOperator CreateFunctionLibraryInjector() {
+      return DefaultTimeSeriesOperators.CreateFunctionLibraryInjector();
     }
 
-    public override IEditor CreateEditor() {
-      return new StandardGpEditor(this);
+    protected override IOperator CreatePostProcessingOperator() {
+      return DefaultTimeSeriesOperators.CreatePostProcessingOperator();
     }
 
-    public override IView CreateView() {
-      return new StandardGpEditor(this);
-    }
-
-    internal static IOperator BestSolutionProcessor {
-      get {
-        SequentialProcessor seq = new SequentialProcessor();
-        TheilInequalityCoefficientEvaluator trainingTheil = new TheilInequalityCoefficientEvaluator();
-        trainingTheil.GetVariableInfo("SamplesStart").ActualName = "ActualTrainingSamplesStart";
-        trainingTheil.GetVariableInfo("SamplesEnd").ActualName = "ActualTrainingSamplesEnd";
-        trainingTheil.GetVariableInfo("TheilInequalityCoefficient").ActualName = "TrainingTheilInequalityCoefficient";
-        trainingTheil.GetVariableInfo("TheilInequalityCoefficientBias").ActualName = "TrainingTheilInequalityCoefficientBias";
-        trainingTheil.GetVariableInfo("TheilInequalityCoefficientVariance").ActualName = "TrainingTheilInequalityCoefficientVariance";
-        trainingTheil.GetVariableInfo("TheilInequalityCoefficientCovariance").ActualName = "TrainingTheilInequalityCoefficientCovariance";
-
-        TheilInequalityCoefficientEvaluator validationTheil = new TheilInequalityCoefficientEvaluator();
-        validationTheil.GetVariableInfo("SamplesStart").ActualName = "ActualValidationSamplesStart";
-        validationTheil.GetVariableInfo("SamplesEnd").ActualName = "ActualValidationSamplesEnd";
-        validationTheil.GetVariableInfo("TheilInequalityCoefficient").ActualName = "ValidationTheilInequalityCoefficient";
-        validationTheil.GetVariableInfo("TheilInequalityCoefficientBias").ActualName = "ValidationTheilInequalityCoefficientBias";
-        validationTheil.GetVariableInfo("TheilInequalityCoefficientVariance").ActualName = "ValidationTheilInequalityCoefficientVariance";
-        validationTheil.GetVariableInfo("TheilInequalityCoefficientCovariance").ActualName = "ValidationTheilInequalityCoefficientCovariance";
-
-        TheilInequalityCoefficientEvaluator testTheil = new TheilInequalityCoefficientEvaluator();
-        testTheil.GetVariableInfo("SamplesStart").ActualName = "ActualTestSamplesStart";
-        testTheil.GetVariableInfo("SamplesEnd").ActualName = "ActualTestSamplesEnd";
-        testTheil.GetVariableInfo("TheilInequalityCoefficient").ActualName = "TestTheilInequalityCoefficient";
-        testTheil.GetVariableInfo("TheilInequalityCoefficientBias").ActualName = "TestTheilInequalityCoefficientBias";
-        testTheil.GetVariableInfo("TheilInequalityCoefficientVariance").ActualName = "TestTheilInequalityCoefficientVariance";
-        testTheil.GetVariableInfo("TheilInequalityCoefficientCovariance").ActualName = "TestTheilInequalityCoefficientCovariance";
-
-        SimpleEvaluator trainingEvaluator = new SimpleEvaluator();
-        trainingEvaluator.GetVariableInfo("SamplesStart").ActualName = "ActualTrainingSamplesStart";
-        trainingEvaluator.GetVariableInfo("SamplesEnd").ActualName = "ActualTrainingSamplesEnd";
-        trainingEvaluator.GetVariableInfo("Values").ActualName = "PredictedValuesTraining";
-
-        SimpleEvaluator validationEvaluator = new SimpleEvaluator();
-        validationEvaluator.GetVariableInfo("SamplesStart").ActualName = "ValidationSamplesStart";
-        validationEvaluator.GetVariableInfo("SamplesEnd").ActualName = "ValidationSamplesEnd";
-        validationEvaluator.GetVariableInfo("Values").ActualName = "PredictedValuesValidation";
-
-        SimpleEvaluator testEvaluator = new SimpleEvaluator();
-        testEvaluator.GetVariableInfo("SamplesStart").ActualName = "TestSamplesStart";
-        testEvaluator.GetVariableInfo("SamplesEnd").ActualName = "TestSamplesEnd";
-        testEvaluator.GetVariableInfo("Values").ActualName = "PredictedValuesTest";
-
-        LinechartInjector trainingChartInjector = new LinechartInjector();
-        trainingChartInjector.GetVariableValue<IntData>("NumberOfLines", null, false).Data = 2;
-        trainingChartInjector.GetVariableInfo("Values").ActualName = "PredictedValuesTraining";
-        trainingChartInjector.GetVariableInfo("Linechart").ActualName = "LinechartTrainingPredictedValues";
-
-        LinechartInjector validationChartInjector = new LinechartInjector();
-        validationChartInjector.GetVariableValue<IntData>("NumberOfLines", null, false).Data = 2;
-        validationChartInjector.GetVariableInfo("Values").ActualName = "PredictedValuesValidation";
-        validationChartInjector.GetVariableInfo("Linechart").ActualName = "LinechartValidationPredictedValues";
-
-        LinechartInjector testChartInjector = new LinechartInjector();
-        testChartInjector.GetVariableValue<IntData>("NumberOfLines", null, false).Data = 2;
-        testChartInjector.GetVariableInfo("Values").ActualName = "PredictedValuesTest";
-        testChartInjector.GetVariableInfo("Linechart").ActualName = "LinechartTestPredictedValues";
-
-        seq.AddSubOperator(trainingTheil);
-        seq.AddSubOperator(validationTheil);
-        seq.AddSubOperator(testTheil);
-        seq.AddSubOperator(trainingEvaluator);
-        seq.AddSubOperator(trainingChartInjector);
-        seq.AddSubOperator(validationEvaluator);
-        seq.AddSubOperator(validationChartInjector);
-        seq.AddSubOperator(testEvaluator);
-        seq.AddSubOperator(testChartInjector);
-
-        return seq;
-      }
+    protected override VariableInjector CreateGlobalInjector() {
+      VariableInjector injector = base.CreateGlobalInjector();
+      injector.AddVariable(new HeuristicLab.Core.Variable("MinTimeOffset", new IntData()));
+      injector.AddVariable(new HeuristicLab.Core.Variable("MaxTimeOffset", new IntData()));
+      injector.AddVariable(new HeuristicLab.Core.Variable("UseEstimatedTargetValue", new BoolData()));
+      return injector;
     }
   }
